program msfx;
{$APPTYPE CONSOLE}

//this program will open main.sfx and will extract or inject the wav files on in.

uses
  SysUtils, strutils;

type
tinfo = packed record
        riff,len:cardinal;
end;

//----auxiliar function
function GetToken(Cadena,Separador:string;Token:integer):string;
 var
   Posicion:integer;
 begin
    while Token > 1 do begin
      Delete(Cadena,1,Pos(Separador,Cadena));
      Dec(Token);
    end;
    Posicion:=Pos(Separador,Cadena);
    if Posicion=0
    then result:=cadena
    else Result:=Copy(Cadena,1,Posicion-Length(Separador));
 end;


//-----------------------
var
f:file;
wave:file;
txt:text;
k:integer;
info:tinfo;
fname:string;
p:pointer;
cpos:cardinal;
comment:string;
begin
  writeln('Main SFX builder, version 1.0');
  writeln('By Turbo Pascal. Tegucigalpa, Honduras, Octubre-2005');
  writeln;
  writeln('Usage:  MSFX -x|b');
  writeln('Switchs: -x : Extract WAV files from MAIN.SFX');
  writeln('         -b : Build MAIN.SFX with the WAV files using main.txt');


  //extract wavs.
  if (paramstr(1)='-x') or (paramstr(1)='-X') then
  begin

     if not fileExists('main.sfx') then
     begin
        writeln('Error...Main.sfx no found.');
        halt;
     end;
     writeln('Extracting WAV files...');

     assignfile(f,'main.sfx');
     reset(f,1);

     assignfile(txt,'main.txt');
     rewrite(txt);

     k:=0;
     p:=nil;
     comment:='This is a comment, write any info you need after the ";"';
     while not eof(f) do
     begin
         cpos:=filepos(f);
         blockread(f,info,sizeof(info));
         fname:=inttostr(k);
         fname:='SFX_'+dupestring('0',4-length(fname))+fname+'.wav';
         getmem(p,info.len+8);
         seek(f,cpos);
         blockread(f,p^,info.len+8);
         //create wav file.
         assign(wave,fname);
         rewrite(wave,1);
         blockwrite(wave,p^,info.len+8);
         close(wave);
         writeln(txt,fname+';'+comment);
         k:=k+1;
         comment:='';
     end;//all wavs.
     close(f);
     close(txt);
     freemem(p);
     writeln('Total WAV extracted:'+inttostr(k));
     halt;
  end; //end extract all wavs from main.sfx


  if (paramstr(1)='-b') or (paramstr(1)='-B') then
  begin
     if not fileExists('main.txt') then
     begin
        writeln('Error...Main.txt no found.');
        halt;
     end;
     writeln('Building MAIN.SFX...');
     assignfile(txt,'main.txt');
     reset(txt);

     assignfile(f,'main.sfx');
     rewrite(f,1);
     k:=0;
     p:=nil;

     while not eof(txt) do
     begin
          readln(txt,fname);
          fname:=gettoken(fname,';',0);
          fname:=trimleft(trim(fname));
          if fname='' then continue;
          if not fileexists(fname) then begin beep;writeln('Error...file not exist:'+fname);break;end;

          AssignFile(wave,fname);
          reset(wave,1);
          getmem(p,filesize(wave));
          blockread(wave,p^,filesize(wave));
          blockwrite(f,p^,filesize(wave));
          closefile(wave);
          k:=k+1;
     end; //end all wavs to inject.
     closefile(txt);
     closefile(f);
     freemem(p);
     writeln('Total WAVs added:'+inttostr(k));
  end; //end extract all wavs from main.sfx



end.
